#include <QtCore>
#include <bundle.h>

///////////////////////////////////////
//Bundle options:
//BIT 0: Send ACK to this bundle option
//BIT 1: ACK Bundle
//BIT 2: PRoPHET Message
//BIT 3: This bundle is an ack (used in bundle requests for letting the other 
//		 node know that the bundle was received. NOT THE PRoPHET ACK!)
//////////////////////////////////////


Bundle::Bundle(QObject *parent)
{
			id=0;
			sourceId=0;
			destinationId=0;
			data.clear();
			options=0;
			sourceString.clear();
			destinationString.clear();
			dataLength=0;
}


Bundle& Bundle::operator=(const Bundle& other)
{
 id = other.id;
 sourceId = other.sourceId;
 destinationId = other.destinationId;
 data = other.data;
 timeStamp = other.timeStamp;
 options = other.options;
 sourceString = other.sourceString;
 destinationString = other.destinationString;
 dataLength = other.dataLength;
 return *this;
}

Bundle::Bundle(const Bundle& other)
{
 id = other.id;
 sourceId = other.sourceId;
 destinationId = other.destinationId;
 data = other.data;
 timeStamp = other.timeStamp;
 options = other.options;
 sourceString = other.sourceString;
 destinationString = other.destinationString;
 dataLength = other.dataLength;
}	
	
void Bundle::setContent(int seq,int s,int d,QByteArray m,int opt,QByteArray src,QByteArray dst)
{
	timeStamp=timeStamp.currentDateTime();
	id=((seq%10000)+(d*10000)+(s*10000000));
	sourceId=s;
	destinationId=d;
	data=m; 
	options=opt;
	sourceString = src;
	destinationString = dst;
	dataLength=data.size();


}
void Bundle::setContent(int seq,int s,int d,QByteArray m,int opt)
{
	timeStamp=timeStamp.currentDateTime();
	id=((seq%10000)+(d*10000)+(s*10000000));
	sourceId=s;
	destinationId=d;
	data=m;
	sourceString.clear();
	destinationString.clear();
	options=opt;
	dataLength=data.size();

}

void Bundle::setAck(){
	options |= 0x8; //set ack-bit
}

void Bundle::unSetAck(){
	options &= 0xF7; //un-set ack-bit
}

bool Bundle::isAck(){
	if((options & 0x08)==0x08)
		return 1;
	else
		return 0;
}
int Bundle::getId()
{
	return id;
}

int Bundle::getSourceId()
{
	return sourceId;
}

int Bundle::getDestinationId()
{
	return destinationId;
}

QByteArray Bundle::getData()
{
	return data;
}

QDateTime Bundle::getTime()
{
	return timeStamp;
}


int Bundle::getOptions()
{
	return options;
}
